"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VerifyBamId(ProtocolElement):
    """
    Verify Bam ID  This is only run on germline samples  * `SEQ_ID`: *
    `CHIP_ID`: * `SNPS`: * `READS`: * `AVG_DP`: * `FREEMIX`: *
    `FREELK1`: * `FREELK0`: * `FREE_RH`: * `FREE_RA`: * `CHIPMIX`: *
    `CHIPLK1`: * `CHIPLK0`: * `CHIP_RA`: * `DPREF`: * `RDPHET`: *
    `RDPALT`:
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "AVG_DP",
        "CHIPLK0",
        "CHIPLK1",
        "CHIPMIX",
        "CHIP_ID",
        "CHIP_RA",
        "DPREF",
        "FREELK0",
        "FREELK1",
        "FREEMIX",
        "FREE_RA",
        "FREE_RH",
        "RDPALT",
        "RDPHET",
        "READS",
        "SEQ_ID",
        "SNPS",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.VerifyBamId": metrics_1_2_2.VerifyBamId,
        }

    __slots__ = [
        "AVG_DP",
        "CHIPLK0",
        "CHIPLK1",
        "CHIPMIX",
        "CHIP_ID",
        "CHIP_RA",
        "DPREF",
        "FREELK0",
        "FREELK1",
        "FREEMIX",
        "FREE_RA",
        "FREE_RH",
        "RDPALT",
        "RDPHET",
        "READS",
        "SEQ_ID",
        "SNPS",
    ]

    def __init__(
        self,
        AVG_DP,
        CHIPLK0,
        CHIPLK1,
        CHIPMIX,
        CHIP_ID,
        CHIP_RA,
        DPREF,
        FREELK0,
        FREELK1,
        FREEMIX,
        FREE_RA,
        FREE_RH,
        RDPALT,
        RDPHET,
        READS,
        SEQ_ID,
        SNPS,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.VerifyBamId model.

        :param AVG_DP:
        :type AVG_DP: double
        :param CHIPLK0:
        :type CHIPLK0: str
        :param CHIPLK1:
        :type CHIPLK1: str
        :param CHIPMIX:
        :type CHIPMIX: str
        :param CHIP_ID:
        :type CHIP_ID: str
        :param CHIP_RA:
        :type CHIP_RA: str
        :param DPREF:
        :type DPREF: str
        :param FREELK0:
        :type FREELK0: double
        :param FREELK1:
        :type FREELK1: double
        :param FREEMIX:
        :type FREEMIX: double
        :param FREE_RA:
        :type FREE_RA: str
        :param FREE_RH:
        :type FREE_RH: str
        :param RDPALT:
        :type RDPALT: str
        :param RDPHET:
        :type RDPHET: str
        :param READS:
        :type READS: double
        :param SEQ_ID:
        :type SEQ_ID: str
        :param SNPS:
        :type SNPS: double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
